﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using System.Threading;

namespace Clarus_Med_Scope_Viewer
{
    public class Logging
    {
        private static readonly object _locker = new object();
        public List<string> _logList = new List<string>();
        private string _logPath;

        private System.Threading.Timer logTimer;
        private int _logCount = 0;
        private int _maxLogCount = 10000;
        private int _writeInterval = 1000;
        private string _logName = "Clarus_Medical_ScopeView";


        public Logging(string LogName)
        {
            _logName = LogName;
            createNewFile();
            logTimer = new Timer(loggingCallback, null, _writeInterval, _writeInterval);
        }

        private void loggingCallback(object state)
        { logData(); }

        private void createNewFile()
        {
            _logCount = 0;
            _logPath = Path.GetTempPath() + "\\" + _logName  + DateTime.Now.ToString("yyyyddMMddhhmmssFFF") + ".txt";
        }

        public void addLog(string message)
        {
            lock(_locker)
            {
                _logList.Add("[" + DateTime.Now.ToString() + "] " + message);
            }
        }

        private void logData()
        {
            logTimer.Change(Timeout.Infinite, Timeout.Infinite);
            if(_logPath.Length >= 0)
            {
                lock (_locker)
                {
                    using (StreamWriter sw = new StreamWriter(_logPath, true))
                    {
                        foreach (string log in _logList)
                        {
                            sw.WriteLine(log);
                            _logCount++;
                        }
                    }
                    _logList.Clear();
                }
            }
            if (_logCount > _maxLogCount)
                createNewFile();

            logTimer.Change(_writeInterval, _writeInterval);
        }
    }
}
