﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Clarus_Med_Scope_Viewer
{
    public partial class frmExclusions : Form
    {
        List<CameraSettingData> _camSetList = new List<CameraSettingData>();
        public List<string> CamExclList = new List<string>();
        public bool FormExcepted = false;

        public frmExclusions(List<CameraSettingData> CameraSettingsList)
        {
            InitializeComponent();
            _camSetList = CameraSettingsList;
        }

        private void frmExclusions_Load(object sender, EventArgs e)
        {
            //add all the connected cameras to the data grid
            foreach(var cam in _camSetList)
            {
                dgvDetectedCams.Rows.Add(cam.CameraName, cam.Moniker);
            }

            //get the excluded Camera Moniker strings from the settings file, mutiple strings are seperated by a comma
            string exclusions = Properties.Settings.Default.CamMonikerExclusions;
            string[] monikerExclusionsArray = exclusions.Split(',');
            foreach(var excl in monikerExclusionsArray)
            {
                if (excl != string.Empty)
                {
                    lbExclusions.Items.Add(excl);
                    CamExclList.Add(excl);
                }
            }

        }

        private void bAddSelectedCamera_Click(object sender, EventArgs e)
        {
            if(dgvDetectedCams.SelectedRows[0].Index != -1)
            {
                if(CamExclList.Contains(dgvDetectedCams.SelectedRows[0].Cells[1].Value.ToString()))
                {
                    MessageBox.Show("Selected camera moniker already exists in exclusion list");
                }
                else
                {
                    CamExclList.Add((dgvDetectedCams.SelectedRows[0].Cells[1].Value.ToString()));
                    lbExclusions.Items.Add((dgvDetectedCams.SelectedRows[0].Cells[1].Value.ToString()));
                }
            }
        }

        private void bClearExclusions_Click(object sender, EventArgs e)
        {
            CamExclList.Clear();
            lbExclusions.Items.Clear();
        }

        private void bRemoveExclusion_Click(object sender, EventArgs e)
        {
            if(lbExclusions.SelectedIndex != -1)
            {
                int indexToRemove = lbExclusions.SelectedIndex;
                lbExclusions.Items.RemoveAt(indexToRemove);
                CamExclList.RemoveAt(indexToRemove);
            }
        }

        private void bOk_Click(object sender, EventArgs e)
        {
            FormExcepted = true;
            this.Close();
        }

        private void bCancel_Click(object sender, EventArgs e)
        {
            FormExcepted = false;
            this.Close();
        }
    }
}
